--- old/usr/src/uts/common/sys/disp.h	2015-05-08 18:10:32.471776680 -0400
+++ new/usr/src/uts/common/sys/disp.h	2015-05-08 18:10:32.478675595 -0400
@@ -30,8 +30,6 @@
 #ifndef _SYS_DISP_H
 #define	_SYS_DISP_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"	/* SVr4.0 1.11	*/
-
 #include <sys/priocntl.h>
 #include <sys/thread.h>
 #include <sys/class.h>
@@ -143,8 +141,6 @@
 extern void		swtch_to(kthread_t *);
 extern void		swtch_from_zombie(void)
 				__NORETURN;
-extern void		dq_sruninc(kthread_t *);
-extern void		dq_srundec(kthread_t *);
 extern void		cpu_rechoose(kthread_t *);
 extern void		cpu_surrender(kthread_t *);
 extern void		kpreempt(int);
--- old/usr/src/uts/common/sys/proc.h	2015-05-08 18:10:32.668461815 -0400
+++ new/usr/src/uts/common/sys/proc.h	2015-05-08 18:10:32.675272707 -0400
@@ -129,10 +129,8 @@
 struct corectl_content;
 
 /*
- * One structure allocated per active process.  It contains all
- * data needed about the process while the process may be swapped
- * out.  Other per-process data (user.h) is also inside the proc structure.
- * Lightweight-process data (lwp.h) and the kernel stack may be swapped out.
+ * One structure allocated per active process.  Per-process data (user.h) is
+ * also inside the proc structure.
  */
 typedef struct	proc {
 	/*
@@ -146,7 +144,6 @@
 	/*
 	 * Fields protected by pidlock
 	 */
-	int	p_swapcnt;		/* number of swapped out lwps */
 	char	p_stat;			/* status of process */
 	char	p_wcode;		/* current wait code */
 	ushort_t p_pidflag;		/* flags protected only by pidlock */
--- old/usr/src/uts/common/sys/sysinfo.h	2015-05-08 18:10:32.885388756 -0400
+++ new/usr/src/uts/common/sys/sysinfo.h	2015-05-08 18:10:32.892140591 -0400
@@ -252,10 +252,6 @@
 	uint64_t pgpgin;		/* pages paged in */
 	uint64_t pgout;			/* pageouts */
 	uint64_t pgpgout;		/* pages paged out */
-	uint64_t swapin;		/* swapins */
-	uint64_t pgswapin;		/* pages swapped in */
-	uint64_t swapout;		/* swapouts */
-	uint64_t pgswapout;		/* pages swapped out */
 	uint64_t zfod;			/* pages zero filled on demand */
 	uint64_t dfree;			/* pages freed by daemon or auto */
 	uint64_t scan;			/* pages examined by pageout daemon */
--- old/usr/src/uts/common/sys/systm.h	2015-05-08 18:10:33.089030777 -0400
+++ new/usr/src/uts/common/sys/systm.h	2015-05-08 18:10:33.096041774 -0400
@@ -63,11 +63,6 @@
 extern struct vnode *devicesdir;	/* pointer to /devices vnode */
 extern int interrupts_unleashed;	/* set after the spl0() in main() */
 
-extern char runin;		/* scheduling flag */
-extern char runout;		/* scheduling flag */
-extern char wake_sched;		/* causes clock to wake swapper on next tick */
-extern char wake_sched_sec;	/* causes clock to wake swapper after a sec */
-
 extern pgcnt_t	maxmem;		/* max available memory (pages) */
 extern pgcnt_t	physmem;	/* physical memory (pages) on this CPU */
 extern pfn_t	physmax;	/* highest numbered physical page present */
--- old/usr/src/uts/common/sys/thread.h	2015-05-08 18:10:33.297068354 -0400
+++ new/usr/src/uts/common/sys/thread.h	2015-05-08 18:10:33.303892324 -0400
@@ -155,9 +155,6 @@
 	struct _kcpc_ctx *t_cpc_ctx;	/* performance counter context */
 	struct _kcpc_set *t_cpc_set;	/* set this thread has bound */
 
-	/*
-	 * non swappable part of the lwp state.
-	 */
 	id_t		t_tid;		/* lwp's id */
 	id_t		t_waitfor;	/* target lwp id in lwp_wait() */
 	struct sigqueue	*t_sigqueue;	/* queue of siginfo structs */
@@ -268,7 +265,6 @@
 		void		  **ts_value;	/* array of value/key */
 	} *t_tsd;
 
-	clock_t		t_stime;	/* time stamp used by the swapper */
 	struct door_data *t_door;	/* door invocation data */
 	kmutex_t	*t_plockp;	/* pointer to process's p_lock */
 
@@ -399,10 +395,6 @@
  * Thread scheduler flag (t_schedflag) definitions.
  *	The thread must be locked via thread_lock() or equiv. to change these.
  */
-#define	TS_LOAD		0x0001	/* thread is in memory */
-#define	TS_DONT_SWAP	0x0002	/* thread/lwp should not be swapped */
-#define	TS_SWAPENQ	0x0004	/* swap thread when it reaches a safe point */
-#define	TS_ON_SWAPQ	0x0008	/* thread is on the swap queue */
 #define	TS_SIGNALLED	0x0010	/* thread was awakened by cv_signal() */
 #define	TS_PROJWAITQ	0x0020	/* thread is on its project's waitq */
 #define	TS_ZONEWAITQ	0x0040	/* thread is on its zone's waitq */
@@ -480,12 +472,6 @@
 #define	ASSIGNED_PRIO(t)	((t)->t_pri)
 
 /*
- * Macros to determine whether a thread can be swapped.
- * If t_lock is held, the thread is either on a processor or being swapped.
- */
-#define	SWAP_OK(t)	(!LOCK_HELD(&(t)->t_lock))
-
-/*
  * proctot(x)
  *	convert a proc pointer to a thread pointer. this only works with
  *	procs that have only one lwp.
@@ -653,12 +639,6 @@
 #define	THREAD_WAIT(tp, lp)	THREAD_SET_STATE(tp, TS_WAIT, lp)
 
 /*
- * Put thread in run state, and set the lock pointer to the dispatcher queue
- * lock pointer provided (i.e., the "swapped_lock").  This lock should be held.
- */
-#define	THREAD_SWAP(tp, lp)	THREAD_SET_STATE(tp, TS_RUN, lp)
-
-/*
  * Put the thread in zombie state and set the lock pointer to NULL.
  * The NULL will catch anything that tries to lock a zombie.
  */
--- old/usr/src/uts/common/sys/vmsystm.h	2015-05-08 18:10:33.513868255 -0400
+++ new/usr/src/uts/common/sys/vmsystm.h	2015-05-08 18:10:33.520677878 -0400
@@ -121,10 +121,8 @@
 struct page;
 struct anon;
 
-extern int maxslp;
 extern ulong_t pginrate;
 extern ulong_t pgoutrate;
-extern void swapout_lwp(klwp_t *);
 
 extern	int valid_va_range(caddr_t *basep, size_t *lenp, size_t minlen,
 		int dir);
--- old/usr/src/uts/common/sys/watchpoint.h	2015-05-08 18:10:33.715690252 -0400
+++ new/usr/src/uts/common/sys/watchpoint.h	2015-05-08 18:10:33.722538203 -0400
@@ -74,7 +74,7 @@
 
 /* wp_flags */
 #define	WP_NOWATCH	0x01	/* protections temporarily restored */
-#define	WP_SETPROT	0x02	/* SEGOP_SETPROT() needed on this page */
+#define	WP_SETPROT	0x02	/* segop_setprot() needed on this page */
 
 #ifdef	_KERNEL
 
--- old/usr/src/uts/common/syscall/utssys.c	2015-05-08 18:10:33.912430640 -0400
+++ new/usr/src/uts/common/syscall/utssys.c	2015-05-08 18:10:33.919223915 -0400
@@ -542,7 +542,7 @@
 				 * segment then skip it
 				 */
 				vp = NULL;
-				if ((SEGOP_GETVP(seg, seg->s_base, &vp)) ||
+				if ((segop_getvp(seg, seg->s_base, &vp)) ||
 				    (vp == NULL))
 					continue;
 
--- old/usr/src/uts/common/vm/anon.h	2015-05-08 18:10:34.131330880 -0400
+++ new/usr/src/uts/common/vm/anon.h	2015-05-08 18:10:34.138147859 -0400
@@ -439,8 +439,6 @@
 extern pgcnt_t	anon_grow(struct anon_hdr *, ulong_t *, pgcnt_t, pgcnt_t, int);
 extern void	anon_array_enter(struct anon_map *, ulong_t,
 			anon_sync_obj_t *);
-extern int	anon_array_try_enter(struct anon_map *, ulong_t,
-			anon_sync_obj_t *);
 extern void	anon_array_exit(anon_sync_obj_t *);
 
 /*
--- old/usr/src/uts/common/vm/as.h	2015-05-08 18:10:34.339474551 -0400
+++ new/usr/src/uts/common/vm/as.h	2015-05-08 18:10:34.346430007 -0400
@@ -125,7 +125,6 @@
 	vnode_t	**a_objectdir;	/* object directory (procfs) */
 	size_t	a_sizedir;	/* size of object directory */
 	struct as_callback *a_callbacks; /* callback list */
-	void *a_xhat;		/* list of xhat providers */
 	proc_t	*a_proc;	/* back pointer to proc */
 	size_t	a_resvsize;	/* size of reserved part of address space */
 };
@@ -135,24 +134,20 @@
 #define	AS_UNMAPWAIT		0x20
 #define	AS_NEEDSPURGE		0x10	/* mostly for seg_nf, see as_purge() */
 #define	AS_NOUNMAPWAIT		0x02
-#define	AS_BUSY			0x01	/* needed by XHAT framework */
 
 #define	AS_ISPGLCK(as)		((as)->a_flags & AS_PAGLCK)
 #define	AS_ISCLAIMGAP(as)	((as)->a_flags & AS_CLAIMGAP)
 #define	AS_ISUNMAPWAIT(as)	((as)->a_flags & AS_UNMAPWAIT)
-#define	AS_ISBUSY(as)		((as)->a_flags & AS_BUSY)
 #define	AS_ISNOUNMAPWAIT(as)	((as)->a_flags & AS_NOUNMAPWAIT)
 
 #define	AS_SETPGLCK(as)		((as)->a_flags |= AS_PAGLCK)
 #define	AS_SETCLAIMGAP(as)	((as)->a_flags |= AS_CLAIMGAP)
 #define	AS_SETUNMAPWAIT(as)	((as)->a_flags |= AS_UNMAPWAIT)
-#define	AS_SETBUSY(as)		((as)->a_flags |= AS_BUSY)
 #define	AS_SETNOUNMAPWAIT(as)	((as)->a_flags |= AS_NOUNMAPWAIT)
 
 #define	AS_CLRPGLCK(as)		((as)->a_flags &= ~AS_PAGLCK)
 #define	AS_CLRCLAIMGAP(as)	((as)->a_flags &= ~AS_CLAIMGAP)
 #define	AS_CLRUNMAPWAIT(as)	((as)->a_flags &= ~AS_UNMAPWAIT)
-#define	AS_CLRBUSY(as)		((as)->a_flags &= ~AS_BUSY)
 #define	AS_CLRNOUNMAPWAIT(as)	((as)->a_flags &= ~AS_NOUNMAPWAIT)
 
 #define	AS_TYPE_64BIT(as)	\
@@ -288,7 +283,6 @@
 	    size_t redzone, size_t off);
 
 int	as_memory(struct as *as, caddr_t *basep, size_t *lenp);
-size_t	as_swapout(struct as *as);
 int	as_incore(struct as *as, caddr_t addr, size_t size, char *vec,
 		size_t *sizep);
 int	as_ctl(struct as *as, caddr_t addr, size_t size, int func, int attr,
--- old/usr/src/uts/common/vm/hat.h	2015-05-08 18:10:34.545267532 -0400
+++ new/usr/src/uts/common/vm/hat.h	2015-05-08 18:10:34.552034034 -0400
@@ -106,12 +106,6 @@
  *	informs hat layer as is being destroyed.  hat layer cannot use as
  *	pointer after this call.
  *
- * void hat_swapin(hat)
- *	allocate any hat resources required for process being swapped in.
- *
- * void hat_swapout(hat)
- *	deallocate hat resources for process being swapped out.
- *
  * size_t hat_get_mapped_size(hat)
  *	returns number of bytes that have valid mappings in hat.
  *
@@ -133,8 +127,6 @@
 void	hat_free_start(struct hat *);
 void	hat_free_end(struct hat *);
 int	hat_dup(struct hat *, struct hat *, caddr_t, size_t, uint_t);
-void	hat_swapin(struct hat *);
-void	hat_swapout(struct hat *);
 size_t	hat_get_mapped_size(struct hat *);
 int	hat_stats_enable(struct hat *);
 void	hat_stats_disable(struct hat *);
--- old/usr/src/uts/common/vm/seg.h	2015-05-08 18:10:34.759848221 -0400
+++ new/usr/src/uts/common/vm/seg.h	2015-05-08 18:10:34.766697848 -0400
@@ -106,7 +106,7 @@
 	uint_t	s_flags;		/* flags for segment, see below */
 	struct	as *s_as;		/* containing address space */
 	avl_node_t s_tree;		/* AVL tree links to segs in this as */
-	struct	seg_ops *s_ops;		/* ops vector: see below */
+	const struct seg_ops *s_ops;	/* ops vector: see below */
 	void *s_data;			/* private data for instance */
 	kmutex_t s_pmtx;		/* protects seg's pcache list */
 	pcache_link_t s_phead;		/* head of seg's pcache list */
@@ -124,7 +124,6 @@
 	int	(*setprot)(struct seg *, caddr_t, size_t, uint_t);
 	int	(*checkprot)(struct seg *, caddr_t, size_t, uint_t);
 	int	(*kluster)(struct seg *, caddr_t, ssize_t);
-	size_t	(*swapout)(struct seg *);
 	int	(*sync)(struct seg *, caddr_t, size_t, int, uint_t);
 	size_t	(*incore)(struct seg *, caddr_t, size_t, char *);
 	int	(*lockop)(struct seg *, caddr_t, size_t, int, int, ulong_t *,
@@ -210,36 +209,6 @@
 #define	SEG_PAGE_ANON		0x20	/* VA has an anonymous page */
 #define	SEG_PAGE_VNODE		0x40	/* VA has a vnode page backing it */
 
-#define	SEGOP_DUP(s, n)		    (*(s)->s_ops->dup)((s), (n))
-#define	SEGOP_UNMAP(s, a, l)	    (*(s)->s_ops->unmap)((s), (a), (l))
-#define	SEGOP_FREE(s)		    (*(s)->s_ops->free)((s))
-#define	SEGOP_FAULT(h, s, a, l, t, rw) \
-		(*(s)->s_ops->fault)((h), (s), (a), (l), (t), (rw))
-#define	SEGOP_FAULTA(s, a)	    (*(s)->s_ops->faulta)((s), (a))
-#define	SEGOP_SETPROT(s, a, l, p)   (*(s)->s_ops->setprot)((s), (a), (l), (p))
-#define	SEGOP_CHECKPROT(s, a, l, p) (*(s)->s_ops->checkprot)((s), (a), (l), (p))
-#define	SEGOP_KLUSTER(s, a, d)	    (*(s)->s_ops->kluster)((s), (a), (d))
-#define	SEGOP_SWAPOUT(s)	    (*(s)->s_ops->swapout)((s))
-#define	SEGOP_SYNC(s, a, l, atr, f) \
-		(*(s)->s_ops->sync)((s), (a), (l), (atr), (f))
-#define	SEGOP_INCORE(s, a, l, v)    (*(s)->s_ops->incore)((s), (a), (l), (v))
-#define	SEGOP_LOCKOP(s, a, l, atr, op, b, p) \
-		(*(s)->s_ops->lockop)((s), (a), (l), (atr), (op), (b), (p))
-#define	SEGOP_GETPROT(s, a, l, p)   (*(s)->s_ops->getprot)((s), (a), (l), (p))
-#define	SEGOP_GETOFFSET(s, a)	    (*(s)->s_ops->getoffset)((s), (a))
-#define	SEGOP_GETTYPE(s, a)	    (*(s)->s_ops->gettype)((s), (a))
-#define	SEGOP_GETVP(s, a, vpp)	    (*(s)->s_ops->getvp)((s), (a), (vpp))
-#define	SEGOP_ADVISE(s, a, l, b)    (*(s)->s_ops->advise)((s), (a), (l), (b))
-#define	SEGOP_DUMP(s)		    (*(s)->s_ops->dump)((s))
-#define	SEGOP_PAGELOCK(s, a, l, p, t, rw) \
-		(*(s)->s_ops->pagelock)((s), (a), (l), (p), (t), (rw))
-#define	SEGOP_SETPAGESIZE(s, a, l, szc) \
-		(*(s)->s_ops->setpagesize)((s), (a), (l), (szc))
-#define	SEGOP_GETMEMID(s, a, mp)    (*(s)->s_ops->getmemid)((s), (a), (mp))
-#define	SEGOP_GETPOLICY(s, a)	    (*(s)->s_ops->getpolicy)((s), (a))
-#define	SEGOP_CAPABLE(s, c)	    (*(s)->s_ops->capable)((s), (c))
-#define	SEGOP_INHERIT(s, a, l, b)   (*(s)->s_ops->inherit)((s), (a), (l), (b))
-
 #define	seg_page(seg, addr) \
 	(((uintptr_t)((addr) - (seg)->s_base)) >> PAGESHIFT)
 
@@ -250,11 +219,9 @@
 #define	IE_RETRY	-2	/* internal to seg layer */
 #define	IE_REATTACH	-3	/* internal to seg layer */
 
-/* Values for SEGOP_INHERIT */
+/* Values for segop_inherit */
 #define	SEGP_INH_ZERO	0x01
 
-int seg_inherit_notsup(struct seg *, caddr_t, size_t, uint_t);
-
 /* Delay/retry factors for seg_p_mem_config_pre_del */
 #define	SEGP_PREDEL_DELAY_FACTOR	4
 /*
@@ -278,6 +245,31 @@
 boolean_t	seg_can_change_zones(struct seg *);
 size_t		seg_swresv(struct seg *);
 
+/* segop wrappers */
+int segop_dup(struct seg *, struct seg *);
+int segop_unmap(struct seg *, caddr_t, size_t);
+void segop_free(struct seg *);
+faultcode_t segop_fault(struct hat *, struct seg *, caddr_t, size_t, enum fault_type, enum seg_rw);
+faultcode_t segop_faulta(struct seg *, caddr_t);
+int segop_setprot(struct seg *, caddr_t, size_t, uint_t);
+int segop_checkprot(struct seg *, caddr_t, size_t, uint_t);
+int segop_kluster(struct seg *, caddr_t, ssize_t);
+int segop_sync(struct seg *, caddr_t, size_t, int, uint_t);
+size_t segop_incore(struct seg *, caddr_t, size_t, char *);
+int segop_lockop(struct seg *, caddr_t, size_t, int, int, ulong_t *, size_t );
+int segop_getprot(struct seg *, caddr_t, size_t, uint_t *);
+u_offset_t segop_getoffset(struct seg *, caddr_t);
+int segop_gettype(struct seg *, caddr_t);
+int segop_getvp(struct seg *, caddr_t, struct vnode **);
+int segop_advise(struct seg *, caddr_t, size_t, uint_t);
+void segop_dump(struct seg *);
+int segop_pagelock(struct seg *, caddr_t, size_t, struct page ***, enum lock_type, enum seg_rw);
+int segop_setpagesize(struct seg *, caddr_t, size_t, uint_t);
+int segop_getmemid(struct seg *, caddr_t, memid_t *);
+struct lgrp_mem_policy_info *segop_getpolicy(struct seg *, caddr_t);
+int segop_capable(struct seg *, segcapability_t);
+int segop_inherit(struct seg *, caddr_t, size_t, uint_t);
+
 #endif	/* _KERNEL */
 
 #ifdef	__cplusplus
--- old/usr/src/uts/common/vm/seg_dev.c	2015-05-08 18:10:34.963944061 -0400
+++ new/usr/src/uts/common/vm/seg_dev.c	2015-05-08 18:10:34.970900228 -0400
@@ -178,44 +178,34 @@
 static int	segdev_gettype(struct seg *, caddr_t);
 static int	segdev_getvp(struct seg *, caddr_t, struct vnode **);
 static int	segdev_advise(struct seg *, caddr_t, size_t, uint_t);
-static void	segdev_dump(struct seg *);
 static int	segdev_pagelock(struct seg *, caddr_t, size_t,
 		    struct page ***, enum lock_type, enum seg_rw);
-static int	segdev_setpagesize(struct seg *, caddr_t, size_t, uint_t);
 static int	segdev_getmemid(struct seg *, caddr_t, memid_t *);
-static lgrp_mem_policy_info_t	*segdev_getpolicy(struct seg *, caddr_t);
-static int	segdev_capable(struct seg *, segcapability_t);
 
 /*
  * XXX	this struct is used by rootnex_map_fault to identify
  *	the segment it has been passed. So if you make it
  *	"static" you'll need to fix rootnex_map_fault.
  */
-struct seg_ops segdev_ops = {
-	segdev_dup,
-	segdev_unmap,
-	segdev_free,
-	segdev_fault,
-	segdev_faulta,
-	segdev_setprot,
-	segdev_checkprot,
-	(int (*)())segdev_badop,	/* kluster */
-	(size_t (*)(struct seg *))NULL,	/* swapout */
-	segdev_sync,			/* sync */
-	segdev_incore,
-	segdev_lockop,			/* lockop */
-	segdev_getprot,
-	segdev_getoffset,
-	segdev_gettype,
-	segdev_getvp,
-	segdev_advise,
-	segdev_dump,
-	segdev_pagelock,
-	segdev_setpagesize,
-	segdev_getmemid,
-	segdev_getpolicy,
-	segdev_capable,
-	seg_inherit_notsup
+const struct seg_ops segdev_ops = {
+	.dup		= segdev_dup,
+	.unmap		= segdev_unmap,
+	.free		= segdev_free,
+	.fault		= segdev_fault,
+	.faulta		= segdev_faulta,
+	.setprot	= segdev_setprot,
+	.checkprot	= segdev_checkprot,
+	.kluster	= (int (*)())segdev_badop,
+	.sync		= segdev_sync,
+	.incore		= segdev_incore,
+	.lockop		= segdev_lockop,
+	.getprot	= segdev_getprot,
+	.getoffset	= segdev_getoffset,
+	.gettype	= segdev_gettype,
+	.getvp		= segdev_getvp,
+	.advise		= segdev_advise,
+	.pagelock	= segdev_pagelock,
+	.getmemid	= segdev_getmemid,
 };
 
 /*
@@ -432,7 +422,7 @@
 		 * Mappings of /dev/null don't count towards the VSZ of a
 		 * process.  Mappings of /dev/null have no mapping type.
 		 */
-		if ((SEGOP_GETTYPE(seg, (seg)->s_base) & (MAP_SHARED |
+		if ((segop_gettype(seg, seg->s_base) & (MAP_SHARED |
 		    MAP_PRIVATE)) == 0) {
 			seg->s_as->a_resvsize -= seg->s_size;
 		}
@@ -2381,14 +2371,6 @@
 }
 
 /*
- * segdev pages are not dumped, so we just return
- */
-/*ARGSUSED*/
-static void
-segdev_dump(struct seg *seg)
-{}
-
-/*
  * ddi_segmap_setup:	Used by drivers who wish specify mapping attributes
  *			for a segment.	Called from a drivers segmap(9E)
  *			routine.
@@ -2480,14 +2462,6 @@
 	return (ENOTSUP);
 }
 
-/*ARGSUSED*/
-static int
-segdev_setpagesize(struct seg *seg, caddr_t addr, size_t len,
-    uint_t szc)
-{
-	return (ENOTSUP);
-}
-
 /*
  * devmap_device: Used by devmap framework to establish mapping
  *                called by devmap_seup(9F) during map setup time.
@@ -4032,20 +4006,6 @@
 	return (0);
 }
 
-/*ARGSUSED*/
-static lgrp_mem_policy_info_t *
-segdev_getpolicy(struct seg *seg, caddr_t addr)
-{
-	return (NULL);
-}
-
-/*ARGSUSED*/
-static int
-segdev_capable(struct seg *seg, segcapability_t capability)
-{
-	return (0);
-}
-
 /*
  * ddi_umem_alloc() non-pageable quantum cache max size.
  * This is just a SWAG.
--- old/usr/src/uts/common/vm/seg_dev.h	2015-05-08 18:10:35.296130416 -0400
+++ new/usr/src/uts/common/vm/seg_dev.h	2015-05-08 18:10:35.302978462 -0400
@@ -118,7 +118,7 @@
 
 #define	SEG_IS_DEVNULL_MAPPING(seg)	\
 	((seg)->s_ops == &segdev_ops &&	\
-	((SEGOP_GETTYPE(seg, (seg)->s_base) & (MAP_SHARED | MAP_PRIVATE)) == 0))
+	((segop_gettype((seg), (seg)->s_base) & (MAP_SHARED | MAP_PRIVATE)) == 0))
 
 extern void segdev_init(void);
 
@@ -126,7 +126,7 @@
 
 extern int segdev_copyto(struct seg *, caddr_t, const void *, void *, size_t);
 extern int segdev_copyfrom(struct seg *, caddr_t, const void *, void *, size_t);
-extern struct seg_ops segdev_ops;
+extern const struct seg_ops segdev_ops;
 
 #endif	/* _KERNEL */
 
--- old/usr/src/uts/common/vm/seg_kmem.c	2015-05-08 18:10:35.492308118 -0400
+++ new/usr/src/uts/common/vm/seg_kmem.c	2015-05-08 18:10:35.499166727 -0400
@@ -428,14 +428,6 @@
 	return (addr);
 }
 
-static void
-segkmem_badop()
-{
-	panic("segkmem_badop");
-}
-
-#define	SEGKMEM_BADOP(t)	(t(*)())segkmem_badop
-
 /*ARGSUSED*/
 static faultcode_t
 segkmem_fault(struct hat *hat, struct seg *seg, caddr_t addr, size_t size,
@@ -457,7 +449,7 @@
 	 */
 	if (segkp_bitmap && seg == &kvseg &&
 	    BT_TEST(segkp_bitmap, btop((uintptr_t)(addr - seg->s_base))))
-		return (SEGOP_FAULT(hat, segkp, addr, size, type, rw));
+		return (segop_fault(hat, segkp, addr, size, type, rw));
 
 	if (rw != S_READ && rw != S_WRITE && rw != S_OTHER)
 		return (FC_NOSUPPORT);
@@ -519,7 +511,7 @@
 	 */
 	if (segkp_bitmap && seg == &kvseg &&
 	    BT_TEST(segkp_bitmap, btop((uintptr_t)(addr - seg->s_base))))
-		return (SEGOP_SETPROT(segkp, addr, size, prot));
+		return (segop_setprot(segkp, addr, size, prot));
 
 	if (prot == 0)
 		hat_unload(kas.a_hat, addr, size, HAT_UNLOAD);
@@ -539,16 +531,16 @@
 	ASSERT(RW_LOCK_HELD(&seg->s_as->a_lock));
 
 	if (seg->s_as != &kas)
-		segkmem_badop();
+		panic("segkmem badop");
 
 	/*
 	 * If it is one of segkp pages, call into segkp.
 	 */
 	if (segkp_bitmap && seg == &kvseg &&
 	    BT_TEST(segkp_bitmap, btop((uintptr_t)(addr - seg->s_base))))
-		return (SEGOP_CHECKPROT(segkp, addr, size, prot));
+		return (segop_checkprot(segkp, addr, size, prot));
 
-	segkmem_badop();
+	panic("segkmem badop");
 	return (0);
 }
 
@@ -563,16 +555,16 @@
 	ASSERT(RW_LOCK_HELD(&seg->s_as->a_lock));
 
 	if (seg->s_as != &kas)
-		segkmem_badop();
+		panic("segkmem badop");
 
 	/*
 	 * If it is one of segkp pages, call into segkp.
 	 */
 	if (segkp_bitmap && seg == &kvseg &&
 	    BT_TEST(segkp_bitmap, btop((uintptr_t)(addr - seg->s_base))))
-		return (SEGOP_KLUSTER(segkp, addr, delta));
+		return (segop_kluster(segkp, addr, delta));
 
-	segkmem_badop();
+	panic("segkmem badop");
 	return (0);
 }
 
@@ -691,7 +683,7 @@
 	 */
 	if (segkp_bitmap && seg == &kvseg &&
 	    BT_TEST(segkp_bitmap, btop((uintptr_t)(addr - seg->s_base))))
-		return (SEGOP_PAGELOCK(segkp, addr, len, ppp, type, rw));
+		return (segop_pagelock(segkp, addr, len, ppp, type, rw));
 
 	npages = btopr(len);
 	nb = sizeof (page_t *) * npages;
@@ -744,27 +736,20 @@
 	ASSERT(RW_LOCK_HELD(&seg->s_as->a_lock));
 
 	if (seg->s_as != &kas)
-		segkmem_badop();
+		panic("segkmem badop");
 
 	/*
 	 * If it is one of segkp pages, call into segkp.
 	 */
 	if (segkp_bitmap && seg == &kvseg &&
 	    BT_TEST(segkp_bitmap, btop((uintptr_t)(addr - seg->s_base))))
-		return (SEGOP_GETMEMID(segkp, addr, memidp));
+		return (segop_getmemid(segkp, addr, memidp));
 
-	segkmem_badop();
+	panic("segkmem badop");
 	return (0);
 }
 
 /*ARGSUSED*/
-static lgrp_mem_policy_info_t *
-segkmem_getpolicy(struct seg *seg, caddr_t addr)
-{
-	return (NULL);
-}
-
-/*ARGSUSED*/
 static int
 segkmem_capable(struct seg *seg, segcapability_t capability)
 {
@@ -773,31 +758,15 @@
 	return (0);
 }
 
-static struct seg_ops segkmem_ops = {
-	SEGKMEM_BADOP(int),		/* dup */
-	SEGKMEM_BADOP(int),		/* unmap */
-	SEGKMEM_BADOP(void),		/* free */
-	segkmem_fault,
-	SEGKMEM_BADOP(faultcode_t),	/* faulta */
-	segkmem_setprot,
-	segkmem_checkprot,
-	segkmem_kluster,
-	SEGKMEM_BADOP(size_t),		/* swapout */
-	SEGKMEM_BADOP(int),		/* sync */
-	SEGKMEM_BADOP(size_t),		/* incore */
-	SEGKMEM_BADOP(int),		/* lockop */
-	SEGKMEM_BADOP(int),		/* getprot */
-	SEGKMEM_BADOP(u_offset_t),	/* getoffset */
-	SEGKMEM_BADOP(int),		/* gettype */
-	SEGKMEM_BADOP(int),		/* getvp */
-	SEGKMEM_BADOP(int),		/* advise */
-	segkmem_dump,
-	segkmem_pagelock,
-	SEGKMEM_BADOP(int),		/* setpgsz */
-	segkmem_getmemid,
-	segkmem_getpolicy,		/* getpolicy */
-	segkmem_capable,		/* capable */
-	seg_inherit_notsup		/* inherit */
+static const struct seg_ops segkmem_ops = {
+	.fault		= segkmem_fault,
+	.setprot	= segkmem_setprot,
+	.checkprot	= segkmem_checkprot,
+	.kluster	= segkmem_kluster,
+	.dump		= segkmem_dump,
+	.pagelock	= segkmem_pagelock,
+	.getmemid	= segkmem_getmemid,
+	.capable	= segkmem_capable,
 };
 
 int
--- old/usr/src/uts/common/vm/seg_kp.c	2015-05-08 18:10:35.736191120 -0400
+++ new/usr/src/uts/common/vm/seg_kp.c	2015-05-08 18:10:35.742963823 -0400
@@ -75,7 +75,6 @@
 /*
  * Private seg op routines
  */
-static void	segkp_badop(void);
 static void	segkp_dump(struct seg *seg);
 static int	segkp_checkprot(struct seg *seg, caddr_t addr, size_t len,
 			uint_t prot);
@@ -94,10 +93,6 @@
 static int	segkp_load(struct hat *hat, struct seg *seg, caddr_t vaddr,
 			size_t len, struct segkp_data *kpd, uint_t flags);
 static struct	segkp_data *segkp_find(struct seg *seg, caddr_t vaddr);
-static int	segkp_getmemid(struct seg *seg, caddr_t addr, memid_t *memidp);
-static lgrp_mem_policy_info_t	*segkp_getpolicy(struct seg *seg,
-    caddr_t addr);
-static int	segkp_capable(struct seg *seg, segcapability_t capability);
 
 /*
  * Lock used to protect the hash table(s) and caches.
@@ -109,8 +104,6 @@
  */
 static struct segkp_cache segkp_cache[SEGKP_MAX_CACHE];
 
-#define	SEGKP_BADOP(t)	(t(*)())segkp_badop
-
 /*
  * When there are fewer than red_minavail bytes left on the stack,
  * segkp_map_red() will map in the redzone (if called).  5000 seems
@@ -145,41 +138,15 @@
 pgcnt_t anon_segkp_pages_locked;	/* See vm/anon.h */
 pgcnt_t anon_segkp_pages_resv;		/* anon reserved by seg_kp */
 
-static struct	seg_ops segkp_ops = {
-	SEGKP_BADOP(int),		/* dup */
-	SEGKP_BADOP(int),		/* unmap */
-	SEGKP_BADOP(void),		/* free */
-	segkp_fault,
-	SEGKP_BADOP(faultcode_t),	/* faulta */
-	SEGKP_BADOP(int),		/* setprot */
-	segkp_checkprot,
-	segkp_kluster,
-	SEGKP_BADOP(size_t),		/* swapout */
-	SEGKP_BADOP(int),		/* sync */
-	SEGKP_BADOP(size_t),		/* incore */
-	SEGKP_BADOP(int),		/* lockop */
-	SEGKP_BADOP(int),		/* getprot */
-	SEGKP_BADOP(u_offset_t),		/* getoffset */
-	SEGKP_BADOP(int),		/* gettype */
-	SEGKP_BADOP(int),		/* getvp */
-	SEGKP_BADOP(int),		/* advise */
-	segkp_dump,			/* dump */
-	segkp_pagelock,			/* pagelock */
-	SEGKP_BADOP(int),		/* setpgsz */
-	segkp_getmemid,			/* getmemid */
-	segkp_getpolicy,		/* getpolicy */
-	segkp_capable,			/* capable */
-	seg_inherit_notsup		/* inherit */
+static const struct seg_ops segkp_ops = {
+	.fault		= segkp_fault,
+	.checkprot	= segkp_checkprot,
+	.kluster	= segkp_kluster,
+	.dump		= segkp_dump,
+	.pagelock	= segkp_pagelock,
 };
 
 
-static void
-segkp_badop(void)
-{
-	panic("segkp_badop");
-	/*NOTREACHED*/
-}
-
 static void segkpinit_mem_config(struct seg *);
 
 static uint32_t segkp_indel;
@@ -760,15 +727,11 @@
  * stack base.  If the amount of stack remaining is questionable
  * (less than red_minavail), then segkp_map_red() will map in the redzone
  * and return 1.  Otherwise, it will return 0.  segkp_map_red() can
- * _only_ be called when:
- *
- *   - it is safe to sleep on page_create_va().
- *   - the caller is non-swappable.
+ * _only_ be called when it is safe to sleep on page_create_va().
  *
  * It is up to the caller to remember whether segkp_map_red() successfully
  * mapped the redzone, and, if so, to call segkp_unmap_red() at a later
- * time.  Note that the caller must _remain_ non-swappable until after
- * calling segkp_unmap_red().
+ * time.
  *
  * Currently, this routine is only called from pagefault() (which necessarily
  * satisfies the above conditions).
@@ -782,8 +745,6 @@
 	caddr_t stkbase;
 #endif
 
-	ASSERT(curthread->t_schedflag & TS_DONT_SWAP);
-
 	/*
 	 * Optimize for the common case where we simply return.
 	 */
@@ -884,7 +845,6 @@
 	    (uintptr_t)PAGEMASK) - PAGESIZE);
 
 	ASSERT(curthread->t_red_pp != NULL);
-	ASSERT(curthread->t_schedflag & TS_DONT_SWAP);
 
 	/*
 	 * Because we locked the mapping down, we can't simply rely
@@ -1399,27 +1359,6 @@
 	return (ENOTSUP);
 }
 
-/*ARGSUSED*/
-static int
-segkp_getmemid(struct seg *seg, caddr_t addr, memid_t *memidp)
-{
-	return (ENODEV);
-}
-
-/*ARGSUSED*/
-static lgrp_mem_policy_info_t	*
-segkp_getpolicy(struct seg *seg, caddr_t addr)
-{
-	return (NULL);
-}
-
-/*ARGSUSED*/
-static int
-segkp_capable(struct seg *seg, segcapability_t capability)
-{
-	return (0);
-}
-
 #include <sys/mem_config.h>
 
 /*ARGSUSED*/
--- old/usr/src/uts/common/vm/seg_kpm.c	2015-05-08 18:10:35.975007349 -0400
+++ new/usr/src/uts/common/vm/seg_kpm.c	2015-05-08 18:10:35.981707427 -0400
@@ -102,39 +102,33 @@
  */
 faultcode_t segkpm_fault(struct hat *hat, struct seg *seg, caddr_t addr,
 			size_t len, enum fault_type type, enum seg_rw rw);
-static void	segkpm_dump(struct seg *);
-static void	segkpm_badop(void);
-static int	segkpm_notsup(void);
-static int	segkpm_capable(struct seg *, segcapability_t);
-
-#define	SEGKPM_BADOP(t)	(t(*)())segkpm_badop
-#define	SEGKPM_NOTSUP	(int(*)())segkpm_notsup
-
-static struct seg_ops segkpm_ops = {
-	SEGKPM_BADOP(int),	/* dup */
-	SEGKPM_BADOP(int),	/* unmap */
-	SEGKPM_BADOP(void),	/* free */
-	segkpm_fault,
-	SEGKPM_BADOP(int),	/* faulta */
-	SEGKPM_BADOP(int),	/* setprot */
-	SEGKPM_BADOP(int),	/* checkprot */
-	SEGKPM_BADOP(int),	/* kluster */
-	SEGKPM_BADOP(size_t),	/* swapout */
-	SEGKPM_BADOP(int),	/* sync */
-	SEGKPM_BADOP(size_t),	/* incore */
-	SEGKPM_BADOP(int),	/* lockop */
-	SEGKPM_BADOP(int),	/* getprot */
-	SEGKPM_BADOP(u_offset_t), /* getoffset */
-	SEGKPM_BADOP(int),	/* gettype */
-	SEGKPM_BADOP(int),	/* getvp */
-	SEGKPM_BADOP(int),	/* advise */
-	segkpm_dump,		/* dump */
-	SEGKPM_NOTSUP,		/* pagelock */
-	SEGKPM_BADOP(int),	/* setpgsz */
-	SEGKPM_BADOP(int),	/* getmemid */
-	SEGKPM_BADOP(lgrp_mem_policy_info_t *),	/* getpolicy */
-	segkpm_capable,		/* capable */
-	seg_inherit_notsup	/* inherit */
+static int	segkpm_pagelock(struct seg *seg, caddr_t addr, size_t len,
+			struct page ***page, enum lock_type type,
+			enum seg_rw rw);
+
+static const struct seg_ops segkpm_ops = {
+	.fault		= segkpm_fault,
+	.pagelock	= segkpm_pagelock,
+//#ifndef SEGKPM_SUPPORT
+#if 0
+#error FIXME: define nop
+	.dup		= nop,
+	.unmap		= nop,
+	.free		= nop,
+	.faulta		= nop,
+	.setprot	= nop,
+	.checkprot	= nop,
+	.kluster	= nop,
+	.sync		= nop,
+	.incore		= nop,
+	.lockop		= nop,
+	.getprot	= nop,
+	.getoffset	= nop,
+	.gettype	= nop,
+	.getvp		= nop,
+	.advise		= nop,
+	.getpolicy	= nop,
+#endif
 };
 
 /*
@@ -284,58 +278,41 @@
 	page_unlock(pp);
 }
 
-static void
-segkpm_badop()
-{
-	panic("segkpm_badop");
-}
-
 #else	/* SEGKPM_SUPPORT */
 
 /* segkpm stubs */
 
 /*ARGSUSED*/
-int segkpm_create(struct seg *seg, void *argsp) { return (0); }
+int segkpm_create(struct seg *seg, void *argsp)
+{
+	return (0);
+}
 
 /* ARGSUSED */
 faultcode_t
 segkpm_fault(struct hat *hat, struct seg *seg, caddr_t addr, size_t len,
 	enum fault_type type, enum seg_rw rw)
 {
-	return ((faultcode_t)0);
+	return (0);
 }
 
 /* ARGSUSED */
-caddr_t segkpm_create_va(u_offset_t off) { return (NULL); }
+caddr_t segkpm_create_va(u_offset_t off)
+{
+	return (NULL);
+}
 
 /* ARGSUSED */
-void segkpm_mapout_validkpme(struct kpme *kpme) {}
-
-static void
-segkpm_badop() {}
-
-#endif	/* SEGKPM_SUPPORT */
-
-static int
-segkpm_notsup()
+void segkpm_mapout_validkpme(struct kpme *kpme)
 {
-	return (ENOTSUP);
 }
 
-/*
- * segkpm pages are not dumped, so we just return
- */
-/*ARGSUSED*/
-static void
-segkpm_dump(struct seg *seg)
-{}
+#endif	/* SEGKPM_SUPPORT */
 
-/*
- * We claim to have no special capabilities.
- */
-/*ARGSUSED*/
+/* ARGSUSED */
 static int
-segkpm_capable(struct seg *seg, segcapability_t capability)
+segkpm_pagelock(struct seg *seg, caddr_t addr, size_t len,
+	struct page ***page, enum lock_type type, enum seg_rw rw)
 {
-	return (0);
+	return (ENOTSUP);
 }
